/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of Mandelbrot.xs. Do not edit this file, edit Mandelbrot.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Mandelbrot.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

double m_limit = 5;
double m_epsilon = 0.001;
unsigned int m_max_iter = 600;
unsigned int m_w = 640;
unsigned int m_h = 480;
double m_x1 = -2.2;
double m_x2 = +1;
double m_y1 = -1.1;
double m_y2 = +1.1;

/* C version (since using point() in XS code fails make test (but passes
   manual runs huh?) */

unsigned int _point(unsigned int x1, unsigned int y1)
  {
  double		za,zb,za1;
  double		za2,zb2;
  double		x,y;
  unsigned int		RETVAL;

  x = (x1 * (m_x2 - m_x1) / m_w) + m_x1;
  y = (y1 * (m_y2 - m_y1) / m_h) + m_y1;
  za = 0;
  zb = 0;
  za2 = 0;
  zb2 = 0;
  RETVAL = 0;
  while (RETVAL++ < m_max_iter)
    {
    za1 = za2 - zb2 + x;
    zb = 2 * za * zb + y;
    za = za1;
    za2 = za * za; zb2 = zb * zb; 
    if (za2 + zb2 > m_limit)
      {
      break;
      }
    }
  if (RETVAL >= m_max_iter)
    {
    RETVAL = 0;
    }
  return RETVAL;
  }


#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 65 "Mandelbrot.c"

XS(XS_Math__Fractal__Mandelbrot_point); /* prototype to pass -Wmissing-prototypes */
XS(XS_Math__Fractal__Mandelbrot_point)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Math::Fractal::Mandelbrot::point", "myclass, x1, y1");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	unsigned int	x1 = (unsigned int)SvUV(ST(1));
	unsigned int	y1 = (unsigned int)SvUV(ST(2));
	unsigned int	RETVAL;
	dXSTARG;
#line 63 "Mandelbrot.xs"
    double		za,zb,za1;
    double		za2,zb2;
    double		x,y;

#line 88 "Mandelbrot.c"
#line 68 "Mandelbrot.xs"
    x = (x1 * (m_x2 - m_x1) / m_w) + m_x1;
    y = (y1 * (m_y2 - m_y1) / m_h) + m_y1;
    za = 0;
    zb = 0;
    za2 = 0;
    zb2 = 0;
    RETVAL = 0;
    while (RETVAL++ < m_max_iter)
      {
      za1 = za2 - zb2 + x;
      zb = 2 * za * zb + y;
      za = za1;
      za2 = za * za; zb2 = zb * zb; 
      if (za2 + zb2 > m_limit)
        {
        break;
        }
      }
    if (RETVAL >= m_max_iter)
      {
      RETVAL = 0;
      }
#line 112 "Mandelbrot.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Math__Fractal__Mandelbrot_hor_line); /* prototype to pass -Wmissing-prototypes */
XS(XS_Math__Fractal__Mandelbrot_hor_line)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Math::Fractal::Mandelbrot::hor_line", "myclass, x1, y1, l");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	unsigned int	x1 = (unsigned int)SvUV(ST(1));
	unsigned int	y1 = (unsigned int)SvUV(ST(2));
	unsigned int	l = (unsigned int)SvUV(ST(3));
	AV *	RETVAL;
#line 104 "Mandelbrot.xs"
    unsigned int	x, x2, i, last, iter, same;
    AV*			a2;

#line 139 "Mandelbrot.c"
#line 108 "Mandelbrot.xs"
    a2 = (AV*)sv_2mortal((SV*)newAV());
    av_extend (a2, l + 1);
    x2 = x1 + l;
    i = 1; same = 0; last = _point (x1,y1);
    for (x = x1; x < x2; x++)
      {
      iter = _point (x,y1);
      av_push( a2, newSViv(iter) );
      if (iter == last) { same++; } else { break; }
      }
    for (;x < x2; x++)
      {
      iter = _point (x,y1);
      av_push( a2, newSViv(iter) );
      }
    av_push( a2, newSViv(same) );
    RETVAL = (AV*)a2;
#line 158 "Mandelbrot.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Math__Fractal__Mandelbrot_ver_line); /* prototype to pass -Wmissing-prototypes */
XS(XS_Math__Fractal__Mandelbrot_ver_line)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Math::Fractal::Mandelbrot::ver_line", "myclass, x1, y1, l");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	unsigned int	x1 = (unsigned int)SvUV(ST(1));
	unsigned int	y1 = (unsigned int)SvUV(ST(2));
	unsigned int	l = (unsigned int)SvUV(ST(3));
	AV *	RETVAL;
#line 140 "Mandelbrot.xs"
    unsigned int	y, y2, i, last, iter, same;
    AV*			a2;

#line 186 "Mandelbrot.c"
#line 144 "Mandelbrot.xs"
    a2 = (AV*)sv_2mortal((SV*)newAV());
    av_extend (a2, l + 1);
    y2 = y1 + l;   
    i = 1; same = 0; last = _point (x1,y1);
    for (y = y1; y < y2; y++)
      {
      iter = _point (x1,y);
      av_push( a2, newSViv(iter) );
      if (iter == last) { same++; } else { break; }
      }
    for (;y < y2; y++)
      {
      iter = _point (x1,y);
      av_push( a2, newSViv(iter) );
      }
    av_push( a2, newSViv(same) );
    RETVAL = a2;
#line 205 "Mandelbrot.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Math__Fractal__Mandelbrot_set_max_iter); /* prototype to pass -Wmissing-prototypes */
XS(XS_Math__Fractal__Mandelbrot_set_max_iter)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Math::Fractal::Mandelbrot::set_max_iter", "myclass, new_max_iter");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	unsigned int	new_max_iter = (unsigned int)SvUV(ST(1));
	unsigned int	RETVAL;
	dXSTARG;
#line 173 "Mandelbrot.xs"
    m_max_iter = new_max_iter;
    if (new_max_iter == 0) { m_max_iter = 1; }		/* at least 1 */
    RETVAL = m_max_iter;
#line 232 "Mandelbrot.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Math__Fractal__Mandelbrot_set_limit); /* prototype to pass -Wmissing-prototypes */
XS(XS_Math__Fractal__Mandelbrot_set_limit)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Math::Fractal::Mandelbrot::set_limit", "myclass, new_limit");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	double	new_limit = (double)SvNV(ST(1));
	double	RETVAL;
	dXSTARG;
#line 188 "Mandelbrot.xs"
    m_limit = new_limit;
    RETVAL = m_limit;
#line 257 "Mandelbrot.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Math__Fractal__Mandelbrot_set_epsilon); /* prototype to pass -Wmissing-prototypes */
XS(XS_Math__Fractal__Mandelbrot_set_epsilon)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Math::Fractal::Mandelbrot::set_epsilon", "myclass, new_e");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	double	new_e = (double)SvNV(ST(1));
	double	RETVAL;
	dXSTARG;
#line 202 "Mandelbrot.xs"
    m_epsilon = new_e;
    RETVAL = m_epsilon;
#line 282 "Mandelbrot.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Math__Fractal__Mandelbrot_set_bounds); /* prototype to pass -Wmissing-prototypes */
XS(XS_Math__Fractal__Mandelbrot_set_bounds)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 7)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Math::Fractal::Mandelbrot::set_bounds", "myclass, nx1, ny1, nx2, ny2, nw, nh");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	double	nx1 = (double)SvNV(ST(1));
	double	ny1 = (double)SvNV(ST(2));
	double	nx2 = (double)SvNV(ST(3));
	double	ny2 = (double)SvNV(ST(4));
	unsigned int	nw = (unsigned int)SvUV(ST(5));
	unsigned int	nh = (unsigned int)SvUV(ST(6));
#line 221 "Mandelbrot.xs"
    m_x1 = nx1;
    m_y1 = ny1;
    m_x2 = nx2;
    m_y2 = ny2;
    m_w = nw;
    m_h = nh;
#line 314 "Mandelbrot.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Math__Fractal__Mandelbrot); /* prototype to pass -Wmissing-prototypes */
XS(boot_Math__Fractal__Mandelbrot)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXSproto("Math::Fractal::Mandelbrot::point", XS_Math__Fractal__Mandelbrot_point, file, "$$$");
        newXSproto("Math::Fractal::Mandelbrot::hor_line", XS_Math__Fractal__Mandelbrot_hor_line, file, "$$$$");
        newXSproto("Math::Fractal::Mandelbrot::ver_line", XS_Math__Fractal__Mandelbrot_ver_line, file, "$$$$");
        newXSproto("Math::Fractal::Mandelbrot::set_max_iter", XS_Math__Fractal__Mandelbrot_set_max_iter, file, "$$");
        newXSproto("Math::Fractal::Mandelbrot::set_limit", XS_Math__Fractal__Mandelbrot_set_limit, file, "$$");
        newXSproto("Math::Fractal::Mandelbrot::set_epsilon", XS_Math__Fractal__Mandelbrot_set_epsilon, file, "$$");
        newXSproto("Math::Fractal::Mandelbrot::set_bounds", XS_Math__Fractal__Mandelbrot_set_bounds, file, "$$$$$$$");
    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

